# This is an auto-generated file. Do not change it manually

from typing import Literal
from ..resource_type_helpers import ResourceTypeDescriptor

type Datasource = Literal[
    'aemet-grid',
    'era5',
    'merra2',
    'noaa',
    'pvgis',
]

type PvradarResourceType = Literal[
    'any',
    'aemet_grid_table',
    'air_density',
    'air_temperature',
    'angle_of_incidence',
    'available_ac_power',
    'available_dc_power',
    'available_grid_power',
    'available_inverter_power',
    'cell_temperature',
    'dc_ohmic_loss_factor',
    'diffuse_horizontal_irradiance',
    'direct_irradiance_on_front',
    'direct_normal_irradiance',
    'effective_poa_irradiance',
    'energy_sales_price',
    'era5_single_level_table',
    'extraterrestrial_radiation',
    'global_horizontal_irradiance',
    'global_poa_irradiance',
    'global_poa_irradiance_on_front',
    'global_poa_irradiance_on_rear',
    'ground_reflected_irradiance_on_front',
    'ground_reflected_irradiance_on_rear',
    'merra2_aerosol_mixing_table',
    'merra2_land_surface_table',
    'merra2_meteo_table',
    'merra2_surface_flux_table',
    'meteo_station_table',
    'module_temperature',
    'particle_mixing_ratio',
    'particle_volume_concentration',
    'pm10_volume_concentration',
    'pm2_5_volume_concentration',
    'pvgis_seriescalc_table',
    'rainfall',
    'rainfall_mass_rate',
    'rainfall_rate',
    'reflection_loss_factor',
    'relative_humidity',
    'revenue',
    'sky_diffuse_irradiance_on_front',
    'snow_coverage',
    'snow_density',
    'snow_depth',
    'snow_depth_water_equivalent',
    'snow_energy_loss',
    'snow_energy_loss_fraction',
    'snow_loss_factor',
    'snow_power_loss',
    'snowfall',
    'snowfall_mass_rate',
    'snowfall_rate',
    'snowfall_water_equivalent',
    'soiling_energy_loss',
    'soiling_energy_loss_fraction',
    'soiling_loss_factor',
    'soiling_power_loss',
    'solar_azimuth_angle',
    'solar_elevation_angle',
    'solar_zenith_angle',
    'spectral_mismatch_loss_factor',
    'surface_azimuth_angle',
    'surface_tilt_angle',
    'total_precipitation',
    'total_precipitation_mass_rate',
    'tracker_rotation_angle',
    'wind_speed',
]

default_datasources: dict[PvradarResourceType, Datasource] = {
    'aemet_grid_table': 'aemet-grid',
    'air_density': 'merra2',
    'air_temperature': 'merra2',
    'era5_single_level_table': 'era5',
    'global_horizontal_irradiance': 'pvgis',
    'merra2_aerosol_mixing_table': 'merra2',
    'merra2_land_surface_table': 'merra2',
    'merra2_meteo_table': 'merra2',
    'merra2_surface_flux_table': 'merra2',
    'particle_mixing_ratio': 'merra2',
    'particle_volume_concentration': 'merra2',
    'pm10_volume_concentration': 'merra2',
    'pm2_5_volume_concentration': 'merra2',
    'pvgis_seriescalc_table': 'pvgis',
    'rainfall': 'merra2',
    'rainfall_mass_rate': 'merra2',
    'rainfall_rate': 'merra2',
    'relative_humidity': 'merra2',
    'snow_density': 'era5',
    'snow_depth': 'merra2',
    'snow_depth_water_equivalent': 'era5',
    'snowfall': 'merra2',
    'snowfall_mass_rate': 'merra2',
    'snowfall_rate': 'merra2',
    'snowfall_water_equivalent': 'era5',
    'total_precipitation_mass_rate': 'merra2',
    'wind_speed': 'pvgis',
}

standard_mapping: dict[PvradarResourceType, dict] = {
    'aemet_grid_table': ResourceTypeDescriptor.make_attrs(
        resource_type='aemet_grid_table',
    ),
    'air_density': ResourceTypeDescriptor.make_attrs(
        resource_type='air_density',
        to_unit='kg/m^3',
        agg='mean',
    ),
    'air_temperature': ResourceTypeDescriptor.make_attrs(
        resource_type='air_temperature',
        to_unit='degC',
        agg='mean',
    ),
    'angle_of_incidence': ResourceTypeDescriptor.make_attrs(
        resource_type='angle_of_incidence',
        to_unit='deg',
        agg='mean',
    ),
    'available_ac_power': ResourceTypeDescriptor.make_attrs(
        resource_type='available_ac_power',
        to_unit='W',
        agg='mean',
    ),
    'available_dc_power': ResourceTypeDescriptor.make_attrs(
        resource_type='available_dc_power',
        to_unit='W',
        agg='mean',
    ),
    'available_grid_power': ResourceTypeDescriptor.make_attrs(
        resource_type='available_grid_power',
        to_unit='W',
        agg='mean',
    ),
    'available_inverter_power': ResourceTypeDescriptor.make_attrs(
        resource_type='available_inverter_power',
        to_unit='W',
        agg='mean',
    ),
    'cell_temperature': ResourceTypeDescriptor.make_attrs(
        resource_type='cell_temperature',
        to_unit='degC',
        agg='mean',
    ),
    'dc_ohmic_loss_factor': ResourceTypeDescriptor.make_attrs(
        resource_type='dc_ohmic_loss_factor',
        to_unit='fraction',
        agg='mean',
    ),
    'diffuse_horizontal_irradiance': ResourceTypeDescriptor.make_attrs(
        resource_type='diffuse_horizontal_irradiance',
        to_unit='W/m^2',
        agg='mean',
    ),
    'direct_irradiance_on_front': ResourceTypeDescriptor.make_attrs(
        resource_type='direct_irradiance_on_front',
        to_unit='W/m^2',
        agg='mean',
    ),
    'direct_normal_irradiance': ResourceTypeDescriptor.make_attrs(
        resource_type='direct_normal_irradiance',
        to_unit='W/m^2',
        agg='mean',
    ),
    'effective_poa_irradiance': ResourceTypeDescriptor.make_attrs(
        resource_type='effective_poa_irradiance',
        to_unit='W/m^2',
        agg='mean',
    ),
    'energy_sales_price': ResourceTypeDescriptor.make_attrs(
        resource_type='energy_sales_price',
        to_unit='currency/MWh',
        agg='mean',
    ),
    'era5_single_level_table': ResourceTypeDescriptor.make_attrs(
        resource_type='era5_single_level_table',
    ),
    'extraterrestrial_radiation': ResourceTypeDescriptor.make_attrs(
        resource_type='extraterrestrial_radiation',
        to_unit='W/m^2',
        agg='mean',
    ),
    'global_horizontal_irradiance': ResourceTypeDescriptor.make_attrs(
        resource_type='global_horizontal_irradiance',
        to_unit='W/m^2',
        agg='mean',
    ),
    'global_poa_irradiance': ResourceTypeDescriptor.make_attrs(
        resource_type='global_poa_irradiance',
        to_unit='W/m^2',
        agg='mean',
    ),
    'global_poa_irradiance_on_front': ResourceTypeDescriptor.make_attrs(
        resource_type='global_poa_irradiance_on_front',
        to_unit='W/m^2',
        agg='mean',
    ),
    'global_poa_irradiance_on_rear': ResourceTypeDescriptor.make_attrs(
        resource_type='global_poa_irradiance_on_rear',
        to_unit='W/m^2',
        agg='mean',
    ),
    'ground_reflected_irradiance_on_front': ResourceTypeDescriptor.make_attrs(
        resource_type='ground_reflected_irradiance_on_front',
        to_unit='W/m^2',
        agg='mean',
    ),
    'ground_reflected_irradiance_on_rear': ResourceTypeDescriptor.make_attrs(
        resource_type='ground_reflected_irradiance_on_rear',
        to_unit='W/m^2',
        agg='mean',
    ),
    'merra2_aerosol_mixing_table': ResourceTypeDescriptor.make_attrs(
        resource_type='merra2_aerosol_mixing_table',
    ),
    'merra2_land_surface_table': ResourceTypeDescriptor.make_attrs(
        resource_type='merra2_land_surface_table',
    ),
    'merra2_meteo_table': ResourceTypeDescriptor.make_attrs(
        resource_type='merra2_meteo_table',
    ),
    'merra2_surface_flux_table': ResourceTypeDescriptor.make_attrs(
        resource_type='merra2_surface_flux_table',
    ),
    'meteo_station_table': ResourceTypeDescriptor.make_attrs(
        resource_type='meteo_station_table',
    ),
    'module_temperature': ResourceTypeDescriptor.make_attrs(
        resource_type='module_temperature',
        to_unit='degC',
        agg='mean',
    ),
    'particle_mixing_ratio': ResourceTypeDescriptor.make_attrs(
        resource_type='particle_mixing_ratio',
        to_unit='kg/kg',
        agg='mean',
    ),
    'particle_volume_concentration': ResourceTypeDescriptor.make_attrs(
        resource_type='particle_volume_concentration',
        to_unit='kg/m^3',
        agg='mean',
    ),
    'pm10_volume_concentration': ResourceTypeDescriptor.make_attrs(
        resource_type='pm10_volume_concentration',
        to_unit='kg/m^3',
        agg='mean',
    ),
    'pm2_5_volume_concentration': ResourceTypeDescriptor.make_attrs(
        resource_type='pm2_5_volume_concentration',
        to_unit='kg/m^3',
        agg='mean',
    ),
    'pvgis_seriescalc_table': ResourceTypeDescriptor.make_attrs(
        resource_type='pvgis_seriescalc_table',
    ),
    'rainfall': ResourceTypeDescriptor.make_attrs(
        resource_type='rainfall',
        to_unit='mm',
        agg='sum',
    ),
    'rainfall_mass_rate': ResourceTypeDescriptor.make_attrs(
        resource_type='rainfall_mass_rate',
        to_unit='kg/m^2/h',
        agg='mean',
    ),
    'rainfall_rate': ResourceTypeDescriptor.make_attrs(
        resource_type='rainfall_rate',
        to_unit='mm/h',
        agg='mean',
    ),
    'reflection_loss_factor': ResourceTypeDescriptor.make_attrs(
        resource_type='reflection_loss_factor',
        to_unit='fraction',
        agg='mean',
    ),
    'relative_humidity': ResourceTypeDescriptor.make_attrs(
        resource_type='relative_humidity',
        to_unit='%',
        agg='mean',
    ),
    'revenue': ResourceTypeDescriptor.make_attrs(
        resource_type='revenue',
        to_unit='currency',
        agg='mean',
    ),
    'sky_diffuse_irradiance_on_front': ResourceTypeDescriptor.make_attrs(
        resource_type='sky_diffuse_irradiance_on_front',
        to_unit='W/m^2',
        agg='mean',
    ),
    'snow_coverage': ResourceTypeDescriptor.make_attrs(
        resource_type='snow_coverage',
        to_unit='fraction',
        agg='mean',
    ),
    'snow_density': ResourceTypeDescriptor.make_attrs(
        resource_type='snow_density',
        to_unit='kg/m^3',
        agg='mean',
    ),
    'snow_depth': ResourceTypeDescriptor.make_attrs(
        resource_type='snow_depth',
        to_unit='mm',
        agg='mean',
    ),
    'snow_depth_water_equivalent': ResourceTypeDescriptor.make_attrs(
        resource_type='snow_depth_water_equivalent',
        to_unit='mm',
        agg='mean',
    ),
    'snow_energy_loss': ResourceTypeDescriptor.make_attrs(
        resource_type='snow_energy_loss',
        to_unit='Wh',
        agg='sum',
    ),
    'snow_energy_loss_fraction': ResourceTypeDescriptor.make_attrs(
        resource_type='snow_energy_loss_fraction',
        to_unit='fraction',
        agg='mean',
    ),
    'snow_loss_factor': ResourceTypeDescriptor.make_attrs(
        resource_type='snow_loss_factor',
        to_unit='fraction',
        agg='mean',
    ),
    'snow_power_loss': ResourceTypeDescriptor.make_attrs(
        resource_type='snow_power_loss',
        to_unit='W',
        agg='mean',
    ),
    'snowfall': ResourceTypeDescriptor.make_attrs(
        resource_type='snowfall',
        to_unit='mm',
        agg='sum',
    ),
    'snowfall_mass_rate': ResourceTypeDescriptor.make_attrs(
        resource_type='snowfall_mass_rate',
        to_unit='kg/m^2/h',
        agg='mean',
    ),
    'snowfall_rate': ResourceTypeDescriptor.make_attrs(
        resource_type='snowfall_rate',
        to_unit='mm/h',
        agg='mean',
    ),
    'snowfall_water_equivalent': ResourceTypeDescriptor.make_attrs(
        resource_type='snowfall_water_equivalent',
        to_unit='mm',
        agg='sum',
    ),
    'soiling_energy_loss': ResourceTypeDescriptor.make_attrs(
        resource_type='soiling_energy_loss',
        to_unit='Wh',
        agg='sum',
    ),
    'soiling_energy_loss_fraction': ResourceTypeDescriptor.make_attrs(
        resource_type='soiling_energy_loss_fraction',
        to_unit='fraction',
        agg='mean',
    ),
    'soiling_loss_factor': ResourceTypeDescriptor.make_attrs(
        resource_type='soiling_loss_factor',
        to_unit='fraction',
        agg='mean',
    ),
    'soiling_power_loss': ResourceTypeDescriptor.make_attrs(
        resource_type='soiling_power_loss',
        to_unit='W',
        agg='mean',
    ),
    'solar_azimuth_angle': ResourceTypeDescriptor.make_attrs(
        resource_type='solar_azimuth_angle',
        to_unit='deg',
        agg='mean',
    ),
    'solar_elevation_angle': ResourceTypeDescriptor.make_attrs(
        resource_type='solar_elevation_angle',
        to_unit='deg',
        agg='mean',
    ),
    'solar_zenith_angle': ResourceTypeDescriptor.make_attrs(
        resource_type='solar_zenith_angle',
        to_unit='deg',
        agg='mean',
    ),
    'spectral_mismatch_loss_factor': ResourceTypeDescriptor.make_attrs(
        resource_type='spectral_mismatch_loss_factor',
        to_unit='fraction',
        agg='mean',
    ),
    'surface_azimuth_angle': ResourceTypeDescriptor.make_attrs(
        resource_type='surface_azimuth_angle',
        to_unit='deg',
        agg='mean',
    ),
    'surface_tilt_angle': ResourceTypeDescriptor.make_attrs(
        resource_type='surface_tilt_angle',
        to_unit='deg',
        agg='mean',
    ),
    'total_precipitation': ResourceTypeDescriptor.make_attrs(
        resource_type='total_precipitation',
        to_unit='mm',
        agg='sum',
    ),
    'total_precipitation_mass_rate': ResourceTypeDescriptor.make_attrs(
        resource_type='total_precipitation_mass_rate',
        to_unit='kg/m^2/h',
        agg='sum',
    ),
    'tracker_rotation_angle': ResourceTypeDescriptor.make_attrs(
        resource_type='tracker_rotation_angle',
        to_unit='deg',
        agg='mean',
    ),
    'wind_speed': ResourceTypeDescriptor.make_attrs(
        resource_type='wind_speed',
        to_unit='m/s',
        agg='mean',
    ),
}
